/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __draw_CameraI_h__
#define __draw_CameraI_h__

namespace fe
{

/**************************************************************************//**
	@brief viewing position

	@ingroup draw
*//***************************************************************************/
class FE_DL_EXPORT CameraI: virtual public Component
{
	public:
		enum Projection
		{
			e_none,
			e_perspective,
			e_ortho,
			e_current
		};

							/// @brief Inverse transform to the viewpoint
virtual
const	SpatialTransform&	cameraMatrix(void) const						=0;

							/// @brief Field of View (degrees)
virtual	Vector2				fov(void) const									=0;

virtual	Projection			projection(void) const							=0;
};

} // namespace

#endif /* __draw_CameraI_h__ */
