import sys
import re
forge = sys.modules["forge"]

def setup(module):

	srcList = [	"grass.pmh",
				"BenderOp",
				"Blade",
				"BladeOp",
				"ClumpOp",
				"ContractOp",
				"CurlOp",
				"DodgeOp",
				"FlatnessOp",
				"KinkOp",
				"ScatterOp",
				"SpineFitOp",
				"TwistBindOp",
				"TwistWrapOp",
				"grassDL" ]

	manifest = 'ext/grass/manifest.cc'
	with open(manifest, 'w') as outfile:
		outfile.write("")
	for src in srcList:
			if re.compile(r'(.*)Op$').match(src):
				with open(manifest, 'a') as outfile:
					outfile.write('\tspManifest->catalog<String>(\n'+
							'\t\t\t"OperatorSurfaceI.' + src + '.fe")='+
							'"fexGrassDL";\n');

	dll = module.DLL( "fexGrassDL", srcList )

	deplibs = forge.corelibs + [
				"feSignalLib",
				"fexMathLib",
				"fexGeometryDLLib",
				"fexOperatorDLLib",
				"fexDataToolDLLib",
				"fexWindowLib"	]

	forge.deps( ["fexGrassDLLib"], deplibs )

	forge.tests += [
			("inspect.exe",		"fexGrassDL",				None,		None) ]

	module.Module( 'test' )
