/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "houdiniEngine.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new String("fexSurfaceDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> a_spMaster)
{
	Library *pLibrary = new Library();
	pLibrary->add<SurfaceAccessibleHapi>(
			"SurfaceAccessibleI.SurfaceAccessibleHapi.fe.hip");
	pLibrary->add<SurfaceAccessibleHapi>(
			"SurfaceAccessibleI.SurfaceAccessibleHapi.fe.hipnc");
	pLibrary->add<SurfaceAccessorHapi>(
			"SurfaceAccessorI.SurfaceAccessorHapi.fe");
	pLibrary->add<SurfaceTrianglesHapi>(
			"SurfaceI.SurfaceTrianglesHapi.fe");
	return pLibrary;
}

FE_DL_EXPORT void InitializeLibrary(sp<Library> spLibrary)
{
}

}
