import os
import sys
forge = sys.modules["forge"]

def setup(module):

	srcList = [	"native.pmh",
				"assertNative",
				"NativeEventContext",
				"NativeEventContextGDI",
				"NativeEventContextXWIN",
				"NativeEventContextCARBON",
				"NativeWindow",
				"NativeWindowGDI",
				"NativeWindowXWIN",
				"NativeWindowCARBON",
				"nativeDL",
				"weight" ]

	dll = module.DLL( "fexNativeWindowDL", srcList )

	dll.linkmap = { "gfxlibs": forge.gfxlibs }

	#HACK
#	forge.opencl_lib="/opt/intel/opencl-1.2-6.4.0.25/lib64"

	if 'opencl' in forge.module_list and os.path.exists('ext/opencl'):
		sys.stdout.write(" opencl")

		forge.cppmap['opencl'] = ' -DFE_USE_OPENCL'
		forge.cppmap['opencl'] += ' -DFE_GL_OPENCL'

		dll.linkmap['opencl'] = "-Xlinker -rpath='" + forge.opencl_lib + "'"
		dll.linkmap['opencl'] += ' -L' + forge.opencl_lib + ' -lOpenCL'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -opencl")
		forge.color_off()

	was_deplibs = forge.corelibs+ [
				"feSignalLib",
				"fexDataToolDLLib",
				"fexWindowDLLib" ]

	deplibs = forge.corelibs + [ "feSignalLib" ]

	# win32
	now_deplibs = forge.corelibs + [
				"feSignalLib",
				"fexDataToolDLLib" ]

	forge.deps( ["fexNativeWindowDLLib"], now_deplibs )

	forge.tests += [
		("inspect.exe",		"fexNativeWindowDL",			None,		None) ]

	module.Module( 'test' )
