/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleCatalog_h__
#define __surface_SurfaceAccessibleCatalog_h__

namespace fe
{

/**************************************************************************//**
    @brief Catalog Surface Binding

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleCatalog:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleCatalog(void);
virtual							~SurfaceAccessibleCatalog(void);

								using SurfaceAccessibleBase::bind;

								//* as SurfaceAccessibleI
virtual	void					bind(Instance a_instance)
								{	setCatalog(
											a_instance.cast< sp<Catalog> >()); }
virtual	BWORD					isBound(void)
								{	return catalog().isValid(); }

								using SurfaceAccessibleBase::attributeSpecs;

virtual	void					attributeSpecs(
										Array<SurfaceAccessibleI::Spec>&
										a_rSpecs,
										SurfaceAccessibleI::Element
										a_element) const;

								using SurfaceAccessibleBase::accessor;

virtual sp<SurfaceAccessorI>	accessor(String a_node,
										SurfaceAccessibleI::Element a_element,
										String a_name,
										SurfaceAccessibleI::Creation a_create);
virtual sp<SurfaceAccessorI>	accessor(String a_node,
										SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute,
										SurfaceAccessibleI::Creation a_create);

								using SurfaceAccessibleBase::discard;

virtual	BWORD					discard(SurfaceAccessibleI::Element a_element,
										String a_name);

								//* Catalog specific
		sp<Catalog>				catalog(void);
		void					setCatalog(sp<Catalog> a_spCatalog)
								{	m_spCatalog=a_spCatalog; }

		void					setKey(String a_key)
								{	m_key=a_key; }
		String					key(void)
								{	return m_key; }

		BWORD					persistant(void)
								{	return m_persistant; }
		void					setPersistant(BWORD a_persistant)
								{	m_persistant=a_persistant; }

	protected:
virtual	void					reset(void);

	private:
		sp<SurfaceAccessorI>	createAccessor(void);

		sp<Catalog>				m_spCatalog;
		String					m_key;
		BWORD					m_persistant;
};

} // namespace

#endif /* __surface_SurfaceAccessibleCatalog_h__ */
